# Contribution Guidelines

Contributions to this repo are very welcome! We follow a fairly standard [merge request 
process](https://docs.gitlab.com/ee/user/project/merge_requests/creating_merge_requests.html) for contributions, subject to the following guidelines:
 
1. [File a GitLab issue](#file-a-gitlab-issue)
1. [Update the documentation](#update-the-documentation)
1. [Update the tests](#update-the-tests)
1. [Update the code](#update-the-code)
1. [Definition of Done](#definition-of-done)
1. [Create a merge request](#create-a-merge-request)
1. [Merge and release](#merge-and-release)

## File a GitLab issue

Before starting any work, we recommend filing a GitLab issue in this repo. This is your chance to ask questions and
get feedback from the maintainers and the community before you sink a lot of time into writing (possibly the wrong) 
code. If there is anything you're unsure about, just ask!

## Update the documentation

We recommend updating the documentation *before* updating any code (see [Readme Driven 
Development](http://tom.preston-werner.com/2010/08/23/readme-driven-development.html)). This ensures the documentation 
stays up to date and allows you to think through the problem at a high level before you get lost in the weeds of 
coding.

## Update the tests

We also recommend updating the automated tests *before* updating any code (see [Test Driven 
Development](https://en.wikipedia.org/wiki/Test-driven_development)). That means you add or update a test case, 
verify that it's failing with a clear error message, and *then* make the code changes to get that test to pass. This 
ensures the tests stay up to date and verify all the functionality in this repo, including whatever new 
functionality you're adding in your contribution. Check out the [test](/test) folder for instructions on running the 
automated tests. 

## Update the code

At this point, make your code changes and use your new test case to verify that everything is working. As you work,
keep in mind two things:

1. Backwards compatibility
1. Downtime

### Backwards compatibility

Please make every effort to avoid unnecessary backwards incompatible changes. With Terraform code, this means:

1. Do not delete, rename, or change the type of input variables.
1. If you add an input variable, it should have a `default`.
1. Do not delete, rename, or change the type of output variables.
1. Do not delete or rename a module in the `modules` folder.

If a backwards incompatible change cannot be avoided, please make sure to call that out when you submit a pull request, 
explaining why the change is absolutely necessary. 

### Downtime

Bear in mind that the Terraform code in this repo is used to run real infrastructure in 
production, and certain types of changes could cause downtime. For example, consider the following:

1. If you rename a resource (e.g. `aws_instance "foo"` -> `aws_instance "bar"`), Terraform will see that as deleting
   the old resource and creating a new one.
1. If you change certain attributes of a resource (e.g. the `name` of an `aws_elb`), the cloud provider (e.g. AWS) may
   treat that as an instruction to delete the old resource and a create a new one. 
   
Deleting certain types of resources (e.g. virtual servers, load balancers) can cause downtime, so when making code
changes, think carefully about how to avoid that. For example, can you avoid downtime by using 
[create_before_destroy](https://www.terraform.io/docs/configuration/resources.html#create_before_destroy)? Or via
the `terraform state` command? If so, make sure to note this in our pull request. If  downtime cannot be avoided, 
please make sure to call that out when you submit a pull request. 

## Definition of Done

Before submitting a pull request, take the time to review our [Definition  of Done](/DOD.md). 

Our definition of done describes the list of criteria that must be met before any work is considered 'done.' Failure to comply with any of these conditions means work is not complete and will probably result in your pull request being refused.

Upon receipt of a pull request, the maintainers of this repo will review code submitted against the [Definition  of Done](/DOD.md) before accepting that pull request into the codebase.

We describe our [Definition  of Done](/DOD.md) at two levels:
1. Merge Pull Request
1. Tag Release


## Create a merge request

[Create a merge request](https://docs.gitlab.com/ee/user/project/merge_requests/creating_merge_requests.html) with your changes. Please make sure
to include the following:

1. A description of the change, including a link to your GitHub issue.
1. The output of your automated test run, preferably in a [GitLab Snippet](https://docs.gitlab.com/ee/user/snippets.html).
1. Any notes on backwards incompatibility or downtime.

## Merge and release   

The maintainers for this repo will review your code and provide feedback. If everything looks good, they will merge the
code and release a new version, which you'll be able to find in the [releases page](../../releases).
